diff --git a/pki/base/util/src/netscape/security/x509/CertificatePoliciesExtension.java b/pki/base/util/src/netscape/security/x509/CertificatePoliciesExtension.java
index 106cc4500f835ac9406e86e2599cb6bec0b9540e..19a986b3791ca8a78ed555f697efcfdd067c602e 100644
--- a/pki/base/util/src/netscape/security/x509/CertificatePoliciesExtension.java
+++ b/pki/base/util/src/netscape/security/x509/CertificatePoliciesExtension.java
@@ -21,6 +21,8 @@ import java.io.IOException;
 import java.io.InputStream;
 import java.io.OutputStream;
 import java.lang.reflect.Array;
+import java.util.Arrays;
+import java.util.Collections;
 import java.util.Enumeration;
 import java.util.Vector;
 
@@ -65,12 +67,11 @@ implements CertAttrSet {
     /**
      * Attribute names.
      */
-    public static final String NAME = "CertificatePolicies";
     public static final String INFOS = "infos"; 
 
 
     // Private data members 
-    private Vector mInfos;
+    private Vector<CertificatePolicyInfo> mInfos;
  
     // Encode this extension value
     private void encodeThis() throws IOException {
@@ -84,7 +85,7 @@ implements CertAttrSet {
         extensionValue = os.toByteArray();
     }
 
-    public CertificatePoliciesExtension(boolean critical, Vector infos) throws IOException {
+    public CertificatePoliciesExtension(boolean critical, Vector<CertificatePolicyInfo> infos) throws IOException {
         this.mInfos = infos;
         this.extensionId = PKIXExtensions.CertificatePolicies_Id;
         this.critical = critical;
@@ -96,7 +97,7 @@ implements CertAttrSet {
      *
      * @param infos the Vector of CertificatePolicyInfo.
      */
-    public CertificatePoliciesExtension(Vector infos) throws IOException {
+    public CertificatePoliciesExtension(Vector<CertificatePolicyInfo> infos) throws IOException {
         this.mInfos = infos;
         this.extensionId = PKIXExtensions.CertificatePolicies_Id;
         this.critical = false;
@@ -109,7 +110,7 @@ implements CertAttrSet {
 	public CertificatePoliciesExtension() {
         this.extensionId = PKIXExtensions.CertificatePolicies_Id; 
         critical = false;
-        mInfos  = new Vector(1,1);
+        mInfos  = new Vector<CertificatePolicyInfo>(1,1);
     }
 
     /**
@@ -135,7 +136,7 @@ implements CertAttrSet {
             throw new IOException("Invalid encoding for " +
                                   "CertificatePoliciesExtension.");
         }
-        mInfos = new Vector(1, 1);
+        mInfos = new Vector<CertificatePolicyInfo>(1, 1);
         while (val.data.available() != 0) {
             DerValue seq = val.data.getDerValue();
             CertificatePolicyInfo info = new CertificatePolicyInfo(seq);
@@ -184,14 +185,15 @@ implements CertAttrSet {
     /**
      * Set the attribute value.
      */
-    public void set(String name, Object obj) throws IOException {
+    @SuppressWarnings("unchecked")
+	public void set(String name, Object obj) throws IOException {
         clearValue();
         if (name.equalsIgnoreCase(INFOS)) {
             if (!(obj instanceof Vector)) {
               throw new IOException("Attribute value should be of" +
                                     " type Vector.");
             }
-            mInfos = (Vector)obj;
+            mInfos = (Vector<CertificatePolicyInfo>)obj;
         } else {
           throw new IOException("Attribute name not recognized by " +
                         "CertAttrSet:CertificatePoliciesExtension.");
@@ -223,22 +225,23 @@ implements CertAttrSet {
     }
  
     /**
-     * Return an enumeration of names of attributes existing within this
+     * Return an enumeration of attributes existing within this
      * attribute.
      */
-    public Enumeration getElements () {
-        Vector elements = new Vector();
+    public Enumeration<Vector<CertificatePolicyInfo>> getAttributes() {
+        Vector<Vector<CertificatePolicyInfo>> elements = new Vector<Vector<CertificatePolicyInfo>>();
         elements.addElement(mInfos);
         return (elements.elements());
     }
  
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName () {
-        return (NAME);
-    }
-
+    private static final String[] NAMES = {INFOS};
+    @Override
+	public Enumeration<String> getAttributeNames() {
+		// TODO Auto-generated method stub
+		return Collections.enumeration(Arrays.asList(NAMES));
+	}
+    
+    
     	public static void main(String args[])
 	{
 
@@ -312,7 +315,7 @@ implements CertAttrSet {
 		qualifiers1.add(qualifierInfo1);
 		CertificatePolicyInfo info1 = new CertificatePolicyInfo(
 			plcyId1, qualifiers1);
-		Vector infos = new Vector();
+		Vector<CertificatePolicyInfo> infos = new Vector<CertificatePolicyInfo>();
 		infos.addElement(info0);
 		infos.addElement(info1);
 		try {
@@ -325,4 +328,6 @@ implements CertAttrSet {
 			System.out.println(e.toString());
 		}
 	}
+
+		
 }
diff --git a/pki/base/util/src/netscape/security/x509/CertificateSerialNumber.java b/pki/base/util/src/netscape/security/x509/CertificateSerialNumber.java
index eeebb873b6f34c4ea0ba692c53c7280655c7bd70..a73a9ec26e7e76c30e6728058cb93f2f835986ff 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateSerialNumber.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateSerialNumber.java
@@ -174,7 +174,7 @@ public class CertificateSerialNumber implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(NUMBER);
  
diff --git a/pki/base/util/src/netscape/security/x509/CertificateSubjectName.java b/pki/base/util/src/netscape/security/x509/CertificateSubjectName.java
index a4dac169767312f1967fb9b13c94fd99a66df490..e9c558efbf9ef71938b688d8f7f312b635ac2e94 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateSubjectName.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateSubjectName.java
@@ -186,7 +186,7 @@ public class CertificateSubjectName implements CertAttrSet, Serializable {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(DN_NAME);
 
diff --git a/pki/base/util/src/netscape/security/x509/CertificateSubjectUniqueIdentity.java b/pki/base/util/src/netscape/security/x509/CertificateSubjectUniqueIdentity.java
index c214546a310738ccd017e4b4e574a272302ee2c5..7a3294cb374db0e318ae195e6cc2db5611b2c0f5 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateSubjectUniqueIdentity.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateSubjectUniqueIdentity.java
@@ -168,7 +168,7 @@ public class CertificateSubjectUniqueIdentity implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(ID);
   
diff --git a/pki/base/util/src/netscape/security/x509/CertificateValidity.java b/pki/base/util/src/netscape/security/x509/CertificateValidity.java
index e0b26428234ffdc027b95abdf9df33e855a7e55f..8188e8b3d74bf149e5168e0fc86733bafe5f40ee 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateValidity.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateValidity.java
@@ -246,7 +246,7 @@ public class CertificateValidity implements CertAttrSet, Serializable {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(NOT_BEFORE);
         elements.addElement(NOT_AFTER);
diff --git a/pki/base/util/src/netscape/security/x509/CertificateVersion.java b/pki/base/util/src/netscape/security/x509/CertificateVersion.java
index d35a012ea9f851d630406d54055fe58d6a3ab031..951509c772bf03fc5a710237481d3a9bc337ce5b 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateVersion.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateVersion.java
@@ -224,7 +224,7 @@ public class CertificateVersion implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(VERSION);
 
diff --git a/pki/base/util/src/netscape/security/x509/CertificateX509Key.java b/pki/base/util/src/netscape/security/x509/CertificateX509Key.java
index cf888eea57a058b6de412dbf776efec574a51c44..f3507a14c3b74c5a33272313928c059f8dce9f22 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateX509Key.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateX509Key.java
@@ -173,7 +173,7 @@ public class CertificateX509Key implements CertAttrSet, Serializable {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(KEY);
 
diff --git a/pki/base/util/src/netscape/security/x509/DeltaCRLIndicatorExtension.java b/pki/base/util/src/netscape/security/x509/DeltaCRLIndicatorExtension.java
index 96f7167c64acdf26fcc19c9f176e3f6dd3409272..5a56547ab1359686acef50e6f28fc5f6f7f0264e 100755
--- a/pki/base/util/src/netscape/security/x509/DeltaCRLIndicatorExtension.java
+++ b/pki/base/util/src/netscape/security/x509/DeltaCRLIndicatorExtension.java
@@ -53,7 +53,6 @@ implements CertAttrSet {
     /**
      * Attribute name.
      */
-    public static final String NAME = "DeltaCRLIndicator";
     public static final String NUMBER = "value";
 
     /**
@@ -66,7 +65,7 @@ implements CertAttrSet {
     static {
         try {
             OIDMap.addAttribute(DeltaCRLIndicatorExtension.class.getName(),
-                                OID, NAME);
+                                OID, DeltaCRLIndicatorExtension.class.getSimpleName());
         } catch (CertificateException e) {}
     }
 
@@ -223,17 +222,11 @@ implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements () {
+    public Enumeration<String> getAttributeNames () {
         Vector<String> elements = new Vector<String>();
         elements.addElement(NUMBER);
         return (elements.elements());
     }
 
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName () {
-        return (NAME);
-    }
 }
 
diff --git a/pki/base/util/src/netscape/security/x509/Extension.java b/pki/base/util/src/netscape/security/x509/Extension.java
index e52a0be70320fef8dbc366d58b9308528f7ff232..431a60f68fa4c3734dfb37cad094af5d8288c3eb 100644
--- a/pki/base/util/src/netscape/security/x509/Extension.java
+++ b/pki/base/util/src/netscape/security/x509/Extension.java
@@ -195,4 +195,9 @@ public class Extension implements Serializable {
         }
         return (s);
     }
+    
+    public final String getName(){
+    	return this.getClass().getSimpleName();
+    }
+    
 }
diff --git a/pki/base/util/src/netscape/security/x509/Extensions.java b/pki/base/util/src/netscape/security/x509/Extensions.java
index 1e728a0a8251848b5a402c6990a2f5838c85f31f..328f4a2ed8781752629e6f486a613f0baa9a2e6b 100644
--- a/pki/base/util/src/netscape/security/x509/Extensions.java
+++ b/pki/base/util/src/netscape/security/x509/Extensions.java
@@ -40,7 +40,7 @@ import netscape.security.util.DerValue;
  * @version 1.11
  * @see CertAttrSet
  */
-public class Extensions extends Vector
+public class Extensions extends Vector<Extension>
 implements CertAttrSet {
     /**
      *
@@ -56,12 +56,13 @@ implements CertAttrSet {
      */
     public static final String NAME = "extensions";
 
-    private Hashtable map;
+    private Hashtable<String, Extension> map;
 
     // Parse the encoded extension
     public void parseExtension(Extension ext) throws IOException {
         try {
-            Class extClass = OIDMap.getClass(ext.getExtensionId());
+            @SuppressWarnings("unchecked")
+			Class<Extension> extClass = (Class<Extension>) OIDMap.getClass(ext.getExtensionId());
             if (extClass == null) {   // Unsupported extension
                 if (ext.isCritical()) {
                     throw new IOException("Unsupported CRITICAL extension: "
@@ -72,8 +73,8 @@ implements CertAttrSet {
                     return;
                 }
             }
-            Class[] params = { Boolean.class, Object.class };
-            Constructor cons = extClass.getConstructor(params);
+            Class<?>[] params = { Boolean.class, Object.class };
+            Constructor<Extension> cons = extClass.getConstructor(params);
 
             byte[] extData = ext.getExtensionValue();
             int extLen = extData.length;
@@ -84,7 +85,7 @@ implements CertAttrSet {
 	    }
 	    Object[] passed = new Object[] {new Boolean(ext.isCritical()),
                                                         value};
-            CertAttrSet certExt = (CertAttrSet)cons.newInstance(passed);
+            Extension certExt = cons.newInstance(passed);
 	    map.put(certExt.getName(), certExt);
             addElement(certExt);
 
@@ -101,7 +102,7 @@ implements CertAttrSet {
      * Default constructor for the certificate attribute.
      */
     public Extensions() {
-        map = new Hashtable();
+        map = new Hashtable<String, Extension>();
     }
 
     /**
@@ -113,7 +114,7 @@ implements CertAttrSet {
     public Extensions(DerInputStream in)
         throws IOException {
 
-        map = new Hashtable();
+        map = new Hashtable<String, Extension>();
         DerValue[] exts = in.getSequence(5);
 
         for (int i = 0; i < exts.length; i++) {
@@ -132,7 +133,7 @@ implements CertAttrSet {
         DerValue val = new DerValue(in);
         DerInputStream str = val.toDerInputStream();
 
-        map = new Hashtable();
+        map = new Hashtable<String, Extension>();
         DerValue[] exts = str.getSequence(5);
 
         for (int i = 0; i < exts.length; i++) {
@@ -175,8 +176,8 @@ implements CertAttrSet {
      * @exception IOException if the object could not be cached.
      */
     public void set(String name, Object obj) throws IOException {
-        map.put(name,obj);
-        addElement(obj);
+        map.put(name,(Extension) obj);
+        addElement((Extension) obj);
     }
 
     /**
@@ -210,14 +211,14 @@ implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration getElements () {
-        return (map.elements());
+    public Enumeration<String> getAttributeNames () {
+        return map.keys();
     }
 
     /**
      * Return the name of this attribute.
      */
     public String getName () {
-        return (NAME);
+        return getClass().getSimpleName();
     }
 }
diff --git a/pki/base/util/src/netscape/security/x509/FreshestCRLExtension.java b/pki/base/util/src/netscape/security/x509/FreshestCRLExtension.java
index ac8e2504fcbdac80db644dfeaff82a6160bdc213..51ebe030983a6a7296400bb8e973689422e0a9e5 100644
--- a/pki/base/util/src/netscape/security/x509/FreshestCRLExtension.java
+++ b/pki/base/util/src/netscape/security/x509/FreshestCRLExtension.java
@@ -81,8 +81,6 @@ public class FreshestCRLExtension extends Extension
     // Cached DER-encoding to improve performance.
     private byte[] cachedEncoding=null;
 
-    // Attribute name
-    public static final String NAME = "FreshestCRL";
 
     // The Object Identifier for this extension.
     public static final String OID = "2.5.29.46";
@@ -90,7 +88,7 @@ public class FreshestCRLExtension extends Extension
     static {
         try {
             OIDMap.addAttribute(FreshestCRLExtension.class.getName(),
-                                OID, NAME);
+                                OID, FreshestCRLExtension.class.getSimpleName());
         } catch (CertificateException e) {}
     }
 
@@ -192,7 +190,7 @@ public class FreshestCRLExtension extends Extension
     // minimal implementation.
     /////////////////////////////////////////////////////////////
     public String toString() {
-        return NAME;
+        return FreshestCRLExtension.class.getSimpleName();
     }
 
     /**
@@ -237,15 +235,14 @@ public class FreshestCRLExtension extends Extension
             "CertAttrSet:FreshestCRLExtension");
     }
 
-    public Enumeration getElements() {
-        return (new Vector()).elements();
+    /*
+     * TODO replacewith empty collection
+     */
+    public Enumeration<String> getAttributeNames() {
+        return (new Vector<String>()).elements();
     }
 
 
-    public String getName() {
-        return NAME;
-    }
-
     /**
      * Test driver.
      */
@@ -324,11 +321,11 @@ public class FreshestCRLExtension extends Extension
 		    list.addElement(this);
         }
 
-        private static Hashtable map = new Hashtable();
-	    private static Vector list = new Vector();
+        private static Hashtable<String, Reason> map = new Hashtable<String, Reason>();
+	    private static Vector<Reason> list = new Vector<Reason>();
 
         public static Reason fromString(String name) {
-            return (Reason) map.get(name);
+            return  map.get(name);
         }
 
         public String getName() {
@@ -364,7 +361,7 @@ public class FreshestCRLExtension extends Extension
 	    public static Reason[] bitArrayToReasonArray(byte[] bitFlags) {
 		    byte first = bitFlags[0];
 		    int size = list.size();
-		    Vector result = new Vector();
+		    Vector<Reason> result = new Vector<Reason>();
 		    for(int i = 0; i < size; i++) {
 			    Reason r = (Reason) list.elementAt(i);
 			    byte b = r.getBitMask();
@@ -375,7 +372,7 @@ public class FreshestCRLExtension extends Extension
 		    size = result.size();
 		    Reason[] retval = new Reason[size];
 		    for(int i=0; i < size; i++) {
-			    retval[i] = (Reason) result.elementAt(i);
+			    retval[i] = result.elementAt(i);
 		    }
 		    return retval;
 	    }
diff --git a/pki/base/util/src/netscape/security/x509/HoldInstructionExtension.java b/pki/base/util/src/netscape/security/x509/HoldInstructionExtension.java
index ee93e4bece87d5cc0549f0bfc1c32cf4142ffea4..7f996250d90602d39d4f23a9dff21f10f2d84e38 100644
--- a/pki/base/util/src/netscape/security/x509/HoldInstructionExtension.java
+++ b/pki/base/util/src/netscape/security/x509/HoldInstructionExtension.java
@@ -54,7 +54,6 @@ implements CertAttrSet {
     /**
      * Attribute name.
      */
-    public static final String NAME = "HoldInstruction";
     public static final String HOLD_INSTRUCTION = "value";
 
     /**
@@ -90,7 +89,7 @@ implements CertAttrSet {
     static {
         try {
             OIDMap.addAttribute(HoldInstructionExtension.class.getName(),
-                                OID, NAME);
+                                OID, HoldInstructionExtension.class.getSimpleName());
         } catch (CertificateException e) {}
     }
 
@@ -351,17 +350,11 @@ implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements () {
+    public Enumeration<String> getAttributeNames () {
         Vector<String> elements = new Vector<String>();
         elements.addElement(HOLD_INSTRUCTION);
         return (elements.elements());
     }
 
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName () {
-        return (NAME);
-    }
 }
 
diff --git a/pki/base/util/src/netscape/security/x509/InvalidityDateExtension.java b/pki/base/util/src/netscape/security/x509/InvalidityDateExtension.java
index cb568c7fa757965e5d94e632e391b9c8d2c1d20a..30909664a51bdb200e1295d8625012c74ab9999e 100755
--- a/pki/base/util/src/netscape/security/x509/InvalidityDateExtension.java
+++ b/pki/base/util/src/netscape/security/x509/InvalidityDateExtension.java
@@ -54,7 +54,6 @@ implements CertAttrSet {
     /**
      * Attribute name.
      */
-    public static final String NAME = "InvalidityDate";
     public static final String INVALIDITY_DATE = "value";
 
     /**
@@ -68,7 +67,7 @@ implements CertAttrSet {
     static {
         try {
             OIDMap.addAttribute(InvalidityDateExtension.class.getName(),
-                                OID, NAME);
+                                OID, InvalidityDateExtension.class.getSimpleName());
         } catch (CertificateException e) {}
     }
 
@@ -230,17 +229,11 @@ implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements () {
+    public Enumeration<String> getAttributeNames () {
         Vector<String> elements = new Vector<String>();
         elements.addElement(INVALIDITY_DATE);
         return (elements.elements());
     }
 
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName () {
-        return (NAME);
-    }
 }
 
diff --git a/pki/base/util/src/netscape/security/x509/IssuerAlternativeNameExtension.java b/pki/base/util/src/netscape/security/x509/IssuerAlternativeNameExtension.java
index dd599ca6fa468c677e8dd4b669761ed2ac31cb08..eeb05c9136fa2e76a5378065df871e128dc025ea 100644
--- a/pki/base/util/src/netscape/security/x509/IssuerAlternativeNameExtension.java
+++ b/pki/base/util/src/netscape/security/x509/IssuerAlternativeNameExtension.java
@@ -59,7 +59,6 @@ extends Extension implements CertAttrSet {
     /**
      * Attribute names.
      */
-    public static final String NAME = "IssuerAlternativeName";
     public static final String ISSUER_NAME = "issuer_name";
 
     // private data members
@@ -223,17 +222,11 @@ extends Extension implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(ISSUER_NAME);
 
 	return (elements.elements());
     }
 
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName() {
-        return (NAME);
-    }
 }
diff --git a/pki/base/util/src/netscape/security/x509/IssuingDistributionPointExtension.java b/pki/base/util/src/netscape/security/x509/IssuingDistributionPointExtension.java
index 51b7001e97b60eb5b34f0324142decaa5cddd55f..2477591e704154b893bb04a2a1ba26f73d553583 100644
--- a/pki/base/util/src/netscape/security/x509/IssuingDistributionPointExtension.java
+++ b/pki/base/util/src/netscape/security/x509/IssuingDistributionPointExtension.java
@@ -106,7 +106,6 @@ public class IssuingDistributionPointExtension extends Extension
     /**
      * Attribute names.
      */
-    public static final String NAME = "IssuingDistributionPoint";
     public static final String ISSUING_DISTRIBUTION_POINT = "issuing_distribution_point";
 
     // Private data members
@@ -119,7 +118,7 @@ public class IssuingDistributionPointExtension extends Extension
     static {
         try {
             OIDMap.addAttribute(IssuingDistributionPointExtension.class.getName(),
-                                OID, NAME);
+                                OID, IssuingDistributionPointExtension.class.getSimpleName());
         } catch (CertificateException e) {}
     }
 
@@ -285,7 +284,7 @@ public class IssuingDistributionPointExtension extends Extension
      */
 
     public String toString() {
-        return NAME;
+        return IssuingDistributionPointExtension.class.getSimpleName();
     }
 
     /**
@@ -345,7 +344,7 @@ public class IssuingDistributionPointExtension extends Extension
         }
     }
 
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(ISSUING_DISTRIBUTION_POINT);
         return (elements.elements());
@@ -353,10 +352,6 @@ public class IssuingDistributionPointExtension extends Extension
     }
 
 
-    public String getName() {
-        return NAME;
-    }
-
     /**
      * Test driver.
      */
diff --git a/pki/base/util/src/netscape/security/x509/KeyUsageExtension.java b/pki/base/util/src/netscape/security/x509/KeyUsageExtension.java
index 7cef592374ec71db5e36b2c69a127fa7055606d3..8d3aa21fc6d05802de9555ec391eff704a3987bd 100644
--- a/pki/base/util/src/netscape/security/x509/KeyUsageExtension.java
+++ b/pki/base/util/src/netscape/security/x509/KeyUsageExtension.java
@@ -58,7 +58,6 @@ implements CertAttrSet {
     /**
      * Attribute names.
      */
-    public static final String NAME = "KeyUsage";
     public static final String DIGITAL_SIGNATURE = "digital_signature";
     public static final String NON_REPUDIATION = "non_repudiation";
     public static final String KEY_ENCIPHERMENT = "key_encipherment";
@@ -386,7 +385,7 @@ implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements () {
+    public Enumeration<String> getAttributeNames () {
         Vector<String> elements = new Vector<String>();
         elements.addElement(DIGITAL_SIGNATURE);
         elements.addElement(NON_REPUDIATION);
@@ -406,10 +405,4 @@ implements CertAttrSet {
 	return (boolean[]) bitString.clone();
     }
 
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName () {
-        return (NAME);
-    }
 }
diff --git a/pki/base/util/src/netscape/security/x509/NSCCommentExtension.java b/pki/base/util/src/netscape/security/x509/NSCCommentExtension.java
index 040126bfed892300a457783bac86db0a9316fced..bc68dadcd1d6777f7853312fbbbb3d072991694b 100644
--- a/pki/base/util/src/netscape/security/x509/NSCCommentExtension.java
+++ b/pki/base/util/src/netscape/security/x509/NSCCommentExtension.java
@@ -51,7 +51,6 @@ implements CertAttrSet {
     /**
      * Attribute names.
      */
-    public static final String NAME = "NSCCommentExtension";
     public static final String INFOS = "infos"; 
     public static final ObjectIdentifier OID = 
        new ObjectIdentifier("2.16.840.1.113730.1.13");
@@ -59,7 +58,7 @@ implements CertAttrSet {
 
 
     // Private data members 
-    private Vector mInfos;
+    private Vector<Object> mInfos;
 
     private PrettyPrintFormat pp = new PrettyPrintFormat(":");
  
@@ -91,7 +90,7 @@ implements CertAttrSet {
         public NSCCommentExtension(boolean critical) {
         this.extensionId = new ObjectIdentifier("2.16.840.1.113730.1.13");
         this.critical = critical;
-        mInfos  = new Vector(1,1);
+        mInfos  = new Vector<Object>(1,1);
     }
 
     /**
@@ -170,14 +169,15 @@ implements CertAttrSet {
     /**
      * Set the attribute value.
      */
-    public void set(String name, Object obj) throws IOException {
+    @SuppressWarnings("unchecked")
+	public void set(String name, Object obj) throws IOException {
         clearValue();
         if (name.equalsIgnoreCase(INFOS)) {
             if (!(obj instanceof Vector)) {
               throw new IOException("Attribute value should be of" +
                                     " type Vector.");
             }
-            mInfos = (Vector)obj;
+            mInfos = (Vector<Object>)obj;
         } else {
           throw new IOException("Attribute name not recognized by " +
                         "CertAttrSet:NSCCommentExtension.");
@@ -212,17 +212,11 @@ implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration getElements () {
-        Vector elements = new Vector();
-        elements.addElement(mInfos);
+    public Enumeration<String> getAttributeNames () {
+        Vector<String> elements = new Vector<String>();
+        elements.addElement(INFOS);
         return (elements.elements());
     }
  
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName () {
-        return (NAME);
-    }
 
 }
diff --git a/pki/base/util/src/netscape/security/x509/NameConstraintsExtension.java b/pki/base/util/src/netscape/security/x509/NameConstraintsExtension.java
index 9a2ac91cefa6148deb6625779604000a52e75c1b..c7928b857e4a917e92bf199430bb40630f380069 100644
--- a/pki/base/util/src/netscape/security/x509/NameConstraintsExtension.java
+++ b/pki/base/util/src/netscape/security/x509/NameConstraintsExtension.java
@@ -73,7 +73,6 @@ implements CertAttrSet {
     /**
      * Attribute names.
      */
-    public static final String NAME = "NameConstraints";
     public static final String PERMITTED_SUBTREES = "permitted_subtrees";
     public static final String EXCLUDED_SUBTREES = "excluded_subtrees";
 
@@ -301,7 +300,7 @@ implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements () {
+    public Enumeration<String> getAttributeNames () {
         Vector<String> elements = new Vector<String>();
         elements.addElement(PERMITTED_SUBTREES);
         elements.addElement(EXCLUDED_SUBTREES);
@@ -309,10 +308,4 @@ implements CertAttrSet {
 	return (elements.elements());
     }
 
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName () {
-        return (NAME);
-    }
 }
